#include "RGB.h"
#include <Arduino.h>
#include <stdint.h>
rgb::rgb(uint8_t redPin, uint8_t greenPin, uint8_t bluePin) {
    pinRed = redPin;
    pinGreen = greenPin;
    pinBlue = bluePin;
    red = 0;
    redTarget = 0;
    green = 0;
    greenTarget = 0;
    blue = 0;
    blueTarget = 0;
	timeToChangeColor = millis();
	timeIntervalToNextColor = 10;

}
void rgb::SetTarget(uint8_t red, uint8_t green, uint8_t blue) {
    redTarget = red;
    greenTarget = green;
    blueTarget = blue;
}

void rgb::SetRandomColors(void) {
	    do {
            redTarget   = random(255);
            greenTarget = random(255);
            blueTarget  = random(255);
        } while (((abs)(redTarget - greenTarget) < 140) && ((abs)(greenTarget - blueTarget) < 140) && ((abs)(blueTarget - redTarget) < 140 ) );

        i++;														// Счетчик смены цветов;
        if (15 == i) { redTarget = 255; greenTarget = 0; blueTarget = 0; }
        if (30 == i) { redTarget = 0; greenTarget = 255; blueTarget = 0; }
        if (45 == i) { redTarget = 0; greenTarget = 0; blueTarget = 255; }
        if (60 == i) { redTarget = 255; greenTarget = 255; blueTarget = 0; }
        if (75 == i) { redTarget = 0; greenTarget = 255; blueTarget = 255; }
        if (90 == i) { redTarget = 255; greenTarget = 0; blueTarget = 255; }
        if (105 == i) { redTarget = 255; greenTarget = 255; blueTarget = 255;
            i = 0;
        }
}

void rgb::SetTimeIntervalToNextColor(unsigned long interval) {
	timeIntervalToNextColor = interval;
}

void rgb::SwitchOnNow(void){        // Включаем ленту на всю дурь
    red = redTarget = green = greenTarget = blue = blueTarget = 255;
    SwitchColorNow(red,green,blue);
}

void rgb::SwitchOffNow(void) {      // Гасим ленту
    red = redTarget = green = greenTarget = blue = blueTarget = 0;
    SwitchColorNow(red,green,blue);
}

void rgb::SwitchColorNow(uint8_t red, uint8_t green = 0, uint8_t blue = 0) {
    analogWrite(pinRed, red);
    analogWrite(pinGreen, red);
    analogWrite(pinBlue, red);
}

bool rgb::UpdateColors() {
	if(millis() > timeToChangeColor) {
		timeToChangeColor = millis() + timeIntervalToNextColor;
		if (red > redTarget) red -= 1;
		if (red < redTarget) red += 1;
		if (green > greenTarget) green -= 1;
		if (green < greenTarget) green += 1;
		if (blue > blueTarget) blue -= 1;
		if (blue < blueTarget) blue += 1;
		SwitchColorNow(red,green,blue);	  // Зажигаем новые цвета
	}
    bool gotAllColors = false;       // Возвращаем информацию о приведении цветов
                                     // Если все цвета достигли целевых
    if((red == redTarget) && (green == greenTarget) && (blue == blueTarget)) {
        gotAllColors = true;
    }
    return gotAllColors;             // Возвращаем true, иначе false;
}
